
package signalValues;

import java.math.BigInteger;

import javax.persistence.Embeddable;
import javax.persistence.Embedded;

/**
 */
@Embeddable
public class IntegerSignalValueImpl extends IntegerSignalValueBaseImpl {

	@Embedded
	BigInteger value;

	public BigInteger getValue() {
		return value;
	}

	public void setValue(BigInteger value) {
		clearOriginalValue();
		if (value == null) {
			setDefined(false);
		} else {
			this.value = value;
			setDefined(true);
		}
	}

	public Double getSignalValueAsDouble() {
		if (!isDefined() || value == null) {
			return null;
		}
		return value.doubleValue();
	}

}
