/**
 *  Copyright (c) 2015, 
 *  BTC Embedded Systems AG, Oldenburg, Germany  
 *  All rights reserved
 *  --------------------------------------------------------- 
 *  $Author: $
 *  $Date:  $
 *  $Revision: $
 **/

package signalValues;

import javax.persistence.Embeddable;
import javax.persistence.Embedded;

/**
 */
@Embeddable
public class PointerSignalInstanceValueImpl extends SignalValueImpl {

	@Embedded
	SignalValueImpl pointedToInstanceValue;

	/**
	 * Constructor
	 */
	public PointerSignalInstanceValueImpl() {
		// never use the original string of the Pointer itself - only from the
		// instanceValue!
		originalValue = null;
	}

	public SignalValueImpl getInstanceValue() {
		return pointedToInstanceValue;
	}

	public void setInstanceValue(SignalValueImpl pointedToInstanceValue) {
		clearOriginalValue();
		this.pointedToInstanceValue = pointedToInstanceValue;
		setDefined(pointedToInstanceValue != null);
	}

	/**
	 * Clear the content of the originalString from the InstanceValue!
	 */
	protected void clearOriginalValue() {
		// never use the original string of the Pointer itself!
		if (getInstanceValue() != null) {
			((SignalValueImpl) getInstanceValue()).clearOriginalValue();
		}
	}

	/**
	 * Get the the originalString from the InstanceValue!
	 */
	public String getOriginalString() {
		// never use the original string of the Pointer itself!
		if (getInstanceValue() != null) {
			return getInstanceValue().getOriginalString();
		} else {
			return null;
		}
	}
	/*
	 * END: Override all Original Value methods !!!
	 */

}
