package signalValues;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

public final class Reproduce {

	public static void main(String[] args) {
		EntityManagerFactory emf = Persistence.createEntityManagerFactory("objectdb:$objectdb/db/test.tmp;drop");
		EntityManager em = emf.createEntityManager();

		// Persist an entity with an embeddable:
		em.getTransaction().begin();
		MyEntity myEntity = new MyEntity();

		PointerSignalInstanceValueImpl pointerSig = new PointerSignalInstanceValueImpl();
		pointerSig.setInstanceValue(new IntegerSignalValueImpl());
		myEntity.embeddables.add(pointerSig);
		em.persist(myEntity);
		em.getTransaction().commit();

		// Update the embeddable:
		em.getTransaction().begin();
		SignalValueImpl embeddable = em.find(MyEntity.class, 1).embeddables.get(0);
		// embeddable.setDefined(false);
		em.getTransaction().commit(); // unexpected state

		// Update the embeddable:
		em.getTransaction().begin();
		pointerSig = (PointerSignalInstanceValueImpl) em.find(MyEntity.class, 1).embeddables.get(0);
		pointerSig.getInstanceValue().setDefined(false);
		em.getTransaction().commit();

		em.close();
		emf.close();
	}

}